%% Funo que calcula as matrizes elementares para um quadriltero de 9 ns
% a partir do quadriltero de referncia.

function [Ke, fe] = ElemQuad9(points,f)

% Pr-alocao das matrizes elementares.
Ke = zeros(9,9);
fe = zeros(9,9);

n = 3;
[x,w] = GaussLegendre2D(n);

for i = 1:n^2
    xi  = x(i,1);
    eta = x(i,2);
    [B, J, psi] = calculoBQuad9(points,xi,eta);
    
    Ke = Ke + (B*B')*det(J)*w(i);
    fe = fe + (psi*det(J)*w(i))';
end
fe = f*fe;

end

