%% Funo que calcula as matrizes elementares para um tringulo de seis ns
% a partir do tringulo de referncia.

function [Ke, fe] = ElemTri6(points,f)

% Pr-alocao das matrizes elementares.
Ke = zeros(6,6);
fe = zeros(6,1);

n = 3;
[x,w] = GaussTri(n);

nIntPoint = size(x,1);
for i = 1:nIntPoint
    xi  = x(i,1);
    eta = x(i,2);
    [B, J, psi] = calculoBTri6(points,xi,eta);
    
    Ke = Ke + (B*B')*det(J)*w(i);
    fe = fe + (psi*det(J)*w(i))';
end
fe = f*fe;

end

